//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#define NDX_INC_LIBS
#include <NukeDX.h>

#include "Unit1.h"
#include "Unit2.h"
#include "Objects.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//   NukeDX
NDX_Screen *NdxScreen;  //   
NDX_Surface gfxArt; //   

BOOL bAppInit=0;  //    
BOOL bRunApp=0;   //  ,   

void UpdateFrame();  //    
void DrawFrame();    //    Back 

void GameInit();            //  
void InitLevel(int num);    //  

//    (  Program_State )
#define PS_NONE 0
#define PS_SHOW_LEVELNUMBER 1
#define PS_SHOW_GAMEOVER 2
#define PS_SHOW_VICTORY 3
#define PS_ACTIVE 10

//      
int Program_State=PS_NONE;


//   
NDX_SpriteControl  Game_Sprites;


int Level;  //  
int Lives;  //   
int Score;  //   

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::New1Click(TObject *Sender)
{

    //  NukeDX   
    if( !bAppInit)  {
	//    NDX_Screen
        NdxScreen = new NDX_Screen;
	// 
        NdxScreen->Create();
	//    320240
        NdxScreen->SetWindowed(0,Handle,320,240);

	//    
        gfxArt.LoadBMP(NdxScreen,NDXST_BESTFIT,"art.bmp",false);

	//   ,   
        bAppInit=true;
    }
    //    .
    New1->Enabled=false;

    GameInit();

	//   ,   
        bRunApp=true;

	//    ,   
        do
        {
	    //   
            UpdateFrame();
	    //    Windows
            Application->ProcessMessages();
        }
        while(bRunApp == true);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    delete NdxScreen;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_ESCAPE)  {
	bRunApp = false;
	Close();
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
    Form2->ShowModal();
}
//---------------------------------------------------------------------------
void UpdateFrame()
{
	//  Back 
	NdxScreen->Back->Clear(0);

	//    Back 
	DrawFrame();

    NdxScreen->ShowFPS(0,0);

	//  Back  Front 
	NdxScreen->Flip();
}

void DrawFrame()
{
    switch (Program_State)
    {
      case PS_SHOW_LEVELNUMBER: ;
      break;
      case PS_SHOW_GAMEOVER: ;
      break;
      case PS_SHOW_VICTORY: ;
      break;
      case PS_ACTIVE:
        Game_Sprites.MoveAll(0);
        Game_Sprites.DrawAll();
      break;
    }




}

//---------------------------------------------------------------------------
void GameInit()
{
//   
    Level=1;
    Lives=3;
    Score=0;

    InitLevel(1);
}
//---------------------------------------------------------------------------
void InitLevel(int num)
{
   char buf[50];
   BOOL bPlayerLoaded=false;
   int type;
   Game_Object *p;

   GO_Level *lev;

    //    
//    Game_Sprites.RemoveAll();

    //    
    sprintf(buf,"level%d.lev",num);
    lev =  new GO_Level(buf);
    Game_Sprites.AddSprite(lev);  //     

    //    
     for(int n=0; n<lev->Level.KolObj; n++)
    {
		p=NULL;
		type=lev->Level.Obj[n].type;
        switch(type)	//   
        {
        case GO_ENEMY1:
            p=new GO_Enemy1();
            break;
        case GO_PLAYER:
            if(bPlayerLoaded)continue;
            p=new GO_Player();
//            Player=p;   //    
            bPlayerLoaded=true;
            break;
        };
		if(p)	//  
		{
			p->Create( &lev->Level.Obj[n] ); // 
	        Game_Sprites.AddSprite(p);		//    
		}
    }

//     ,    
	 if( !bPlayerLoaded )
        {
            MessageBox( Application->Handle, "Object Player not found in this level", "Dander Dungeon Game", MB_OK );
            return;  //FALSE;
        }
//MessageBox( Application->Handle, "I'm here!", "Debug", MB_OK );

Program_State=PS_ACTIVE;


}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
        bRunApp=false;
}
//---------------------------------------------------------------------------

